(test-group "Elliptic Curve Cryptography"

  (test-assert "Signature and verification"
    (let ([sign (ecc-sign brainpool-P160r1 not-quite-random-integer)]
	  [verify (ecc-verify brainpool-P160r1)])
      (verify Pa not-quite-random-message (sign da not-quite-random-message))))

  (test-assert "Bad signature and verification"
    (let ([sign (ecc-sign brainpool-P160r1 not-quite-random-integer)]
	  [verify (ecc-verify brainpool-P160r1)])
      (not (verify Pb not-quite-random-message (sign da not-quite-random-message)))))

  (test-assert "Secret generation"
    (let ([generate-secret (ecc-generate-secret brainpool-P160r1)])
      (equal?
       (generate-secret da Pb)
       (generate-secret db Pa))))

  (test-assert "Bad secret generation"
    (let ([generate-secret (ecc-generate-secret brainpool-P160r1)])
      (not (equal?
	    (generate-secret db Pb)
	    (generate-secret da Pa)))))

  )
